local CT_NUM_PLAYERTARGETS = 10;
local CT_MOVING_DRAGFRAME = nil;
CT_NUM_SHOWN_PLAYERTARGETS = 0;

function CT_RAPlayerTargets_GetAvailableTarget()
	if ( CT_NUM_SHOWN_PLAYERTARGETS < CT_NUM_PLAYERTARGETS ) then
		return getglobal("CT_RAPlayerTargetMember" .. (CT_NUM_SHOWN_PLAYERTARGETS+1));
	end
end

function CT_RAPlayerTargets_AddNewTarget(unit)
	local obj = CT_RAPlayerTargets_GetAvailableTarget();
	if ( obj ) then
		local dragFrame = getglobal("CT_RAPlayerTargetDrag" .. obj:GetID());
		local cursorX, cursorY = GetCursorPosition();
		
		obj.unit = unit;
		obj:Show();
		obj.parent = dragFrame;
		
		dragFrame.child = obj;
		dragFrame.nextMember = nil;
		dragFrame.prevMember = nil;
		dragFrame:Show();
		dragFrame:ClearAllPoints();
		dragFrame:SetPoint("CENTER", "UIParent", "BOTTOMLEFT", cursorX*GetScreenWidthScale(), cursorY*GetScreenHeightScale());
		
		CT_RAPlayerTargets_AttachMember(dragFrame, obj);
		CT_RAPlayerTargets_StartMovingTarget(dragFrame);
		CT_NUM_SHOWN_PLAYERTARGETS = CT_NUM_SHOWN_PLAYERTARGETS + 1;
	end
end

function CT_RAPlayerTargets_StartMovingTarget(frame)
	local child = frame.child;
	frame:StartMoving();
	CT_MOVING_DRAGFRAME = frame;
	child.dragFrame.numMembers = child.dragFrame.numMembers - 1;
	if ( frame.prevMember ) then
		if ( frame.nextMember ) then
			child.dragFrame.numMembers = child.dragFrame.numMembers - 1;
			frame.prevMember.nextMember = frame.nextMember;
			frame.nextMember.prevMember = frame.prevMember;
			CT_RAPlayerTargets_AttachMember(child.dragFrame, frame.nextMember.child);
			frame.nextMember = nil;
		else
			frame.prevMember.nextMember = nil;
		end
	end
	frame.prevMember = nil;
end

function CT_RAPlayerTargets_StopMovingTarget()
	if ( CT_MOVING_DRAGFRAME ) then
		CT_MOVING_DRAGFRAME:StopMovingOrSizing();
		local dragFrame = CT_RAPlayerTargets_ProcessDragAttachments(CT_MOVING_DRAGFRAME);
		if ( dragFrame ) then
			CT_RAPlayerTargets_AttachMember(dragFrame, CT_MOVING_DRAGFRAME.child);
		else
			CT_RAPlayerTargets_AttachMember(CT_MOVING_DRAGFRAME, CT_MOVING_DRAGFRAME.child);
		end
		CT_MOVING_DRAGFRAME = nil;
	end
end

function CT_RAPlayerTargets_UnitIsTarget(unit)
	for i = 1, CT_NUM_SHOWN_PLAYERTARGETS, 1 do
		local obj = getglobal("CT_RAPlayerTargetMember" .. i);
		if ( obj.unit == unit ) then
			return true;
		end
	end
	return false;
end

function CT_RAPlayerTargets_GetMember(dragFrame, memberID)
	local counter = 0;
	local nextMember = dragFrame.nextMember;
	while ( nextMember ) do
		counter = counter + 1;
		if ( counter == memberID ) then
			return nextMember.child;
		end
		nextMember = nextMember.nextMember;
	end
	return dragFrame.child;
end

function CT_RAPlayerTargets_AttachMember(dragFrame, memberFrame)
	if ( dragFrame ~= memberFrame.parent ) then
		local attachTo = CT_RAPlayerTargets_GetMember(dragFrame, dragFrame.numMembers);
		memberFrame.parent:ClearAllPoints();
		memberFrame.parent:SetPoint("TOP", attachTo:GetName(), "BOTTOM", 0, 2);
		dragFrame.numMembers = dragFrame.numMembers + 1;
		attachTo.parent.nextMember = memberFrame.parent;
		memberFrame.parent.prevMember = attachTo.parent;
	else
		memberFrame:ClearAllPoints();
		memberFrame:SetPoint("TOP", dragFrame:GetName(), "BOTTOM", 0, 10);
		dragFrame.numMembers = 1;
		dragFrame.nextMember = nil;
		dragFrame.prevMember = nil;
	end
	memberFrame.dragFrame = dragFrame;
end

function CT_RAPlayerTargets_ProcessDragAttachments(dragFrame)
	for i = 1, CT_NUM_SHOWN_PLAYERTARGETS, 1 do
		local obj = getglobal("CT_RAPlayerTargetMember" .. i);
		if ( MouseIsOver(obj) or MouseIsOver(obj.parent) ) then
			local isValid = true;
			if ( obj ~= dragFrame.child and obj.parent ~= dragFrame ) then
				return obj.parent;
			end
		end
	end
end