GuildBank = {};
BankOpenedOnce = false;
local GBVersion = "0.2";

function GuildBank_OnLoad()
	--his:RegisterEvent("CHAT_MSG_WHISPER");
	--this:RegisterEvent("PLAYER_ENTERING_WORLD");
	
	SlashCmdList["GuildBank"] = GuildBank_SlashHandler;
	SLASH_GuildBank1 = "/gb";
	SLASH_GuildBank2 = "/GB";
	
	this:RegisterEvent("BANKFRAME_OPENED");
	this:RegisterEvent("PLAYERBANKSLOTS_CHANGED");
	this:RegisterEvent("BAG_UPDATE");
	
	DEFAULT_CHAT_FRAME:AddMessage("GuildBank Version "..GBVersion.." loaded. ");
end


function GuildBank_OnEvent(event)
	if (event == "BANKFRAME_OPENED") then
		BankOpenedOnce = true;
	end
	if (BankOpenedOnce==true and ((event == "BANKFRAME_OPENED") or (event == "PLAYERBANKSLOTS_CHANGED" and arg1 == nil) or (event == "BAG_UPDATE" and arg1 >= 6 and arg1 <= 10))) then
		GB_StorePlayerItems();
		GB_StoreBankItems();
	end
end

function GuildBank_SlashHandler(msg)
	--GuildBank_SnapShots[SnapShotName]["Raid"] = RaidList;
	GB_PrintAll();
end


function GBPrint(msg)
	DEFAULT_CHAT_FRAME:AddMessage("GB: "..msg);
end

function GB_PrintAll()
	--GBPrint("Printing it");
	local i, v;
	local player = UnitName("player");
	for i, v in ipairs(GuildBank[player]["Bank"]) do GBPrint("Bank: " .. i .. " x " .. v) end
	for i, v in ipairs(GuildBank[player]["Bags"]) do GBPrint("Bags: " .. i .. " x " .. v) end
end

function GB_NameFromLink(link)
	local s,e=string.find(link,"%[.*]");
	local itemname = string.sub(link,s+1,e-1);
	s,e = string.find(link,"item:%d+:%d+:%d+:%d+");
	local itemid = string.sub(link,s,e);
	local _,_,_,_,itype,isubtype = GetItemInfo(itemid);
	--GBPrint(link..": "..itype.." :: "..isubtype.." :: "..ITEM_CLASSES_ALLOWED);
	return itemname;
end

--StoredPlace can be: "Bank","Bags","Player" for Bank, Player's Bags, and Currently Equipped
function GB_StoreBag(BagNum,StoredPlace)
	local items,name;
	local player = UnitName("player");
	local i;
	local qty;
	local s,e;
	--GBPrint("Bag: "..BagNum);
	items = GetContainerNumSlots(BagNum);
	--GBPrint("Items in "..BagNum..": "..items);
	if (items) then
		for i = 1, items do
			link = GetContainerItemLink(BagNum, i);
			_, qty = GetContainerItemInfo(BagNum, i);
			
			if( link ) then
				name = GB_NameFromLink(link)
				classlvl = GB_GetClassAndLevelOfItem(BagNum,i);
				local totalitem = name..classlvl;
				
				if (GuildBank[player][StoredPlace][totalitem]==nil) then
					GuildBank[player][StoredPlace][totalitem]=qty;
				else
					GuildBank[player][StoredPlace][totalitem]=GuildBank[player][StoredPlace][totalitem]+qty;
				end
			end
		end
	end
end

function GB_StorePlayer()
	local StoredPlace="Player";
	local player=UnitName("player");
	local classlvl;
	local i, link, name, s, e
	for i = 0,19 do
		link = GetInventoryItemLink("player", i);
		
		if (link) then
			name = GB_NameFromLink(link);
			classlvl = GB_GetClassAndLevelOfItem("player",i);
			--GBPrint(name..class);
			GuildBank[player][StoredPlace][name..classlvl]=1;
		end
	end
end
	
function GB_StoreBankItems()
	local StoredPlace="Bank";
	local player = UnitName("player");
	local i;
	GuildBank[player][StoredPlace]={};
	GB_StoreBag(BANK_CONTAINER,StoredPlace);
	for i = 5,10 do
		GB_StoreBag(i,StoredPlace);
	end
end

function GB_StorePlayerItems()
	local i;
	local player=UnitName("player");
	local StoredPlace="Bags";
	if(GuildBank[player]==nil) then
		GuildBank[player]={};
	end
	GuildBank[player]["Player"]={};
	GB_StorePlayer();

	GuildBank[player]["Bags"]={};
	for i = 0,4 do
		GB_StoreBag(i,StoredPlace);
	end
end

function GB_GetClassAndLevelOfItem(bag,slot)
	local tooltip = getglobal("GameTooltip");
	tooltip:SetText("");
	if(bag=="player") then
		tooltip:SetInventoryItem("player",slot);
	else
		tooltip:SetBagItem(bag,slot);
	end
	local textadd="";
	for i = 1,15 do
		local left = getglobal("GameTooltipTextLeft"..i);
		local text;
		if left ~= nil then
			text = left:GetText();
			if text~=nil then
				local s,e = string.find(text,"Classes:");
				if s~=nil and e~=nil then
					textadd = textadd..";;"..string.sub(text,10,-1);
				else
					local s1,e1 = string.find(text,"Level %d+");
					if s1~=nil and e1~=nil then
						
						textadd = textadd..";;"..string.sub(text,s1,e1);
					end
				end	
			end
			
		end
	end
	return textadd;
end
	
