--PetExtend.lua
--Holds most of the meat of the addon.

--myAddons information
PetExtendDetails = {
	name = "PetExtend",
	version = PETEXTEND_VERSION,
	releaseDate = "June 13, 2006",
	author = "Mpstark",
	email = "Mpstark@gmail.com",
	website = "www.mpstark.wowinterface.com",
	category = MYADDONS_CATEGORY_CLASS
};

--Register for Parser
local parser = ParserLib:GetInstance("1.1");

--Pet DPS Table
PetExtend_DPS = { };

--Global Variables
PetExtend_InPVP = false;
PetExtend_InCombat = false;
PetExtend_PickedUpSpell = "";
PetExtend_PickedUpSpellbook = "";
PetExtend_SmartButton_CallOff = 0;
PetExtend_NextFocusTime = 0;
PetExtend_MoodSwitch = false;
PetExtend_SelectedDNAEntry = 1;
PetExtend_SelectedFocusEntry = nil;
PetExtend_SelectedEntry = nil;

--Global Constants
PETEXTEND_FOCUSINTERVAL = 4.70;
PETEXTEND_FOCUSPERTICK = 24;

--Local Variables
local PetExtend_FocusSample1 = 100;
local PetExtend_FocusSample2 = 100;
local PetExtend_LoadedEvents = false;
local PetExtend_UpdateInterval = 0.125;
local PetExtend_BindingAction_ClickTimes = {0, 0, 0, 0};
local PetExtend_SmartButton_ClickTime = 0;
local PetExtend_PvPOldMode = nil;
local PetExtend_HealthWarned = false;

--Local Constants
local DOUBLECLICK_TIME = .5;

--Pet Actions
PetExtend_PetAction ={};

--Hunter PetActions
if (UnitClass("player") == PE_HUNTER) then
	PetExtend_PetAction[PE_GROWL] = {id = -1, cost = 15, rank = 0};
	PetExtend_PetAction[PE_COWER] = {id = -1, cost = 15, rank = 0};
	PetExtend_PetAction[PE_SCREECH] = {id = -1, cost = 20, rank = 0};
	PetExtend_PetAction[PE_CLAW] = {id = -1, cost = 25, rank = 0};
	PetExtend_PetAction[PE_BITE] = {id = -1, cost = 35, rank = 0};
	PetExtend_PetAction[PE_POISON] = {id = -1, cost = 30, rank = 0};
	PetExtend_PetAction[PE_LIGHTNING] = {id = -1, cost = 50, rank = 0};
	PetExtend_PetAction[PE_STOMP] = {id = -1, cost = 60, rank = 0};
	PetExtend_PetAction[PE_HOWL] = {id = -1, cost = 60, rank = 0};
	PetExtend_PetAction[PE_SHELL] = {id = -1, cost = 10, rank = 0};
	PetExtend_PetAction[PE_DASH] = {id = -1, cost = 20, rank = 0};
	PetExtend_PetAction[PE_DIVE] = {id = -1, cost = 20, rank = 0};
	PetExtend_PetAction[PE_CHARGE] = {id = -1, cost = 35, rank = 0};
	PetExtend_PetAction[PE_PROWL] = {id = -1, cost = 40, rank = 0};
end

--Warlock pet actions
if (UnitClass("player") == PE_WARLOCK) then
	PetExtend_PetAction[PE_SACRIFICE] = {id = -1, cost = 0, rank = 0};
	PetExtend_PetAction[PE_INVIS] = {id = -1, cost = 100, rank = 0};
	PetExtend_PetAction[PE_SEDUCTION] = {id = -1, cost = 0, rank = 0};
	PetExtend_PetAction[PE_PHASESHIFT] = {id = -1, cost = 0, rank = 0};
	PetExtend_PetAction[PE_BLOODPACT] = {id = -1,  cost = 0, rank = 0};
	PetExtend_PetAction[PE_PARANOIA] = {id = -1, cost = 0, rank = 0};
	PetExtend_PetAction[PE_DEVOUR] = {id = -1, cost = 0, rank = 0, costDB = {100, 130, 170, 215}};
	PetExtend_PetAction[PE_SPELLLOCK] = {id = -1, cost = 0, rank = 0, costDB = {120, 200}};
	PetExtend_PetAction[PE_TAINTEDBLOOD] = {id = -1, cost = 0, rank = 0, costDB = {75, 105, 135, 170}};
	PetExtend_PetAction[PE_FIRESHIELD] = {id = -1, cost = 0, rank = 0, costDB = {60, 90, 115, 140, 165}};
	PetExtend_PetAction[PE_FIREBOLT] = {id = -1, cost = 0, rank = 0, costDB = {10, 20, 35, 50, 70, 95, 115}};
	PetExtend_PetAction[PE_LASH] = {id = -1, cost = 0, rank = 0, costDB = {65, 80, 105, 125, 145, 160}};
	PetExtend_PetAction[PE_KISS] = {id = -1, cost = 0, rank = 0, costDB = {30, 50, 75, 100}};
	PetExtend_PetAction[PE_CONSUME] = {id = -1, cost = 0, rank = 0, costDB = {85, 150, 215, 285, 380, 480}};
	PetExtend_PetAction[PE_SUFFERING] = {id = -1, cost = 0, rank = 0, costDB = {150, 300, 450, 600}};
	PetExtend_PetAction[PE_TORMENT] = {id = -1, cost = 0, rank = 0, costDB = {20, 40, 65, 90, 115, 145}};
end


local PetExtend_DefaultConfig = { 
	versionLoaded = PETEXTEND_VERSION,
	enabled = true,
	status = true,
	statusName = true,
	statusDPS = true,
	statusMode = true,
	statusLabels = true,
	statusFocusBar = true,
	statusHealthBar = true,
	statusFocusIndicator = true,
	statusScale = 100,
	enhPetBar = true,
	enhPetBarCC = true,
	enhPetBarShade = true,
	attackskillPlayerEnable = true,
	attackskillPlayer = nil,
	clearAggroList = true,
	scriptOnAttackEnable = false,
	scriptOnAttack = "",
	smartCheck = true,
	debuffcheck = true,
	nochaseCheck = true,
	raidsafe = false,	
	healthCheck = false,
	moodManagement = true,	
	selectedMood = "",
	DoNotAttackEnable = true,
	DoNotAttackList = {},
	partyControl = true,
	partyControlLeaderOnly = false,
	partyControlCalloff = true,
	partyControlDismiss = true,
	partyControlMoods = true,	
	partyControlModes = true,	
	focusmanagement = true,
	skillmanagement = true,
	pvptaunt = true,
	calloffaudio = true,
	nochase = true,	
	pvpfeign_enabled = true,
	pvpfeign_reaction = "Follow",
	scattershot_enabled = true,
	scattershot_reaction = "Stay",
	partywarn_enable = true,
	partywarn_style = "Default",
	partywarn_attack = false,
	partywarn_assist = false,
	partywarn_death = false,
	partywarn_health = false,
	partywarn_healthpercent = 30,
	partywarn_healthAudio = true,
	partywarn_healthCalloff = true,
	partywarn_warning_channel = "Console",
	Minimap = {}
};

local PetExtend_DefaultPetConfig = {
	versionLoaded = PETEXTEND_VERSION,
	attackskillEnable = "",
	attackskill = "",
	smartattackskill = false,
	dashdive = false,
	smartdashdive = false,
	currentmode = PE_MODE_DEFAULT
};


--Intialization Functions
function PetExtend_OnLoad()	
	--Purpose: Register events, slash commands, popups, and hook all functions.

	--Register Events and hook functions
	if ((UnitClass("player") == PE_HUNTER) or (UnitClass("player") == PE_WARLOCK)) then
		--RegisterEvents
		PetExtend_RegisterEvents("load");
		
		--Hook UseAction
		Pre_PetExtend_UseAction = UseAction;
		UseAction = PetExtend_UseAction
		
		--Hook PetActionBar Updater
		Pre_PetExtend_PetActionBar_Update = PetActionBar_Update;
		PetActionBar_Update = PetExtend_PetActionBar_Update;
		
		--Hook OnClick function for PetActionButtons
		Pre_PetExtend_PetActionButton_OnClick = PetActionButton_OnClick;
		PetActionButton_OnClick = PetExtend_PetActionButton_OnClick;
		
		--Hook CastPetAction
		Pre_PetExtend_CastPetAction = CastPetAction;
		CastPetAction = PetExtend_CastPetAction;
		
		--Hook TogglePetAutocast
		Pre_PetExtend_TogglePetAutocast = TogglePetAutocast;
		TogglePetAutocast = PetExtend_TogglePetAutocast;
		
		--Hook PetAttack
		Pre_PetExtend_PetAttack = PetAttack;
		PetAttack = PetExtend_PetAttack;
		
		--Hook PickupSpell
		Pre_PetExtend_PickupSpell = PickupSpell;
		PickupSpell = PetExtend_PickupSpell;
		
		--Hook PetAggresiveMood
		Pre_PetExtend_PetAggressiveMode = PetAggressiveMode;
		PetAggressiveMode = PetExtend_PetAggressiveMode;
		
		--Hook PetDefensiveMood
		Pre_PetExtend_PetDefensiveMode = PetDefensiveMode;
		PetDefensiveMode = PetExtend_PetDefensiveMode;
		
		--Hook PetPassiveMood
		Pre_PetExtend_PetPassiveMode = PetPassiveMode;
		PetPassiveMode = PetExtend_PetPassiveMode;
		
		--Register Slash Commands
		SLASH_PETEXTEND1 = "/petextend";
		SLASH_PETEXTEND2 = "/pe";
		SLASH_PETEXTEND3 = "/PE";
		SLASH_PETEXTEND4 = "/Petextend";
		SLASH_PETEXTEND5 = "/PetExtend";
		SlashCmdList["PETEXTEND"] = function(msg)
			PetExtend_OnChatCommand(msg);
		end
		
		--Register static popups
		StaticPopupDialogs["PE_SWITCHMOODS_DIALOG"] = {
			text = PE_SWITCHMOOD_TEXT,
			button1 = TEXT(ACCEPT),
			button2 = TEXT(CANCEL),
			OnAccept = function(arg1)
				PetExtend_SwitchMood(arg1)
			end,
			OnCancel = function()
				PetExtend_SwitchMood("default");
			end,
			timeout = 0,
			whileDead = 0,
			hideOnEscape = 1,
			showAlert = 1
		};
		
		StaticPopupDialogs["PE_ADD_DNAENTRY"] = {
			text = PE_ADD_DNAENTRY,
			button1 = TEXT(ACCEPT),
			button2 = TEXT(CANCEL),
			hasEditBox = 1,
			maxLetters = 32,
			OnAccept = function()
				local editBox = getglobal(this:GetParent():GetName().."EditBox");
				PetExtend_DNA_AddEntry(editBox:GetText());
			end,
			OnShow = function()
				getglobal(this:GetName().."EditBox"):SetFocus();
			end,
			OnHide = function()
				if ( ChatFrameEditBox:IsVisible() ) then
					ChatFrameEditBox:SetFocus();
				end
				getglobal(this:GetName().."EditBox"):SetText("");
			end,
			EditBoxOnEnterPressed = function()
				local editBox = getglobal(this:GetParent():GetName().."EditBox");
				PetExtend_DNA_AddEntry(editBox:GetText());
				this:GetParent():Hide();
			end,
			EditBoxOnEscapePressed = function()
				this:GetParent():Hide();
			end,
			timeout = 0,
			exclusive = 1,
			whileDead = 1,
			hideOnEscape = 1
		};
		
		StaticPopupDialogs["PE_ADD_MODE"] = {
			text = PE_ADD_MODE,
			button1 = TEXT(ACCEPT),
			button2 = TEXT(CANCEL),
			hasEditBox = 1,
			maxLetters = 8,
			OnAccept = function()
				local editBox = getglobal(this:GetParent():GetName().."EditBox");
				PetExtend_AddMode(editBox:GetText());
			end,
			OnShow = function()
				getglobal(this:GetName().."EditBox"):SetFocus();
			end,
			OnHide = function()
				if ( ChatFrameEditBox:IsVisible() ) then
					ChatFrameEditBox:SetFocus();
				end
				getglobal(this:GetName().."EditBox"):SetText("");
			end,
			EditBoxOnEnterPressed = function()
				local editBox = getglobal(this:GetParent():GetName().."EditBox");
				PetExtend_AddMode(editBox:GetText());
				this:GetParent():Hide();
			end,
			EditBoxOnEscapePressed = function()
				this:GetParent():Hide();
			end,
			timeout = 0,
			exclusive = 1,
			whileDead = 1,
			hideOnEscape = 1
		};
		
	else
		PetExtend_ConsoleMessage(PE_MESSAGE_LOAD_INCOMPATIBLECLASS, "stamped");
		parser:UnregisterAllEvents("PetExtend");
		return;
	end
	
end

function PetExtend_NewPet()
	--Purpose: Create pet varibles if not already created.
	
	if ((UnitExists("pet")) and ((not (UnitName("pet") == PE_UNKNOWN_ENTITY)) and (not (UnitName("pet") == PE_UNKNOWN)))) then
		--Pet exists, is fully loaded and is ready to have it's config loaded. Load all pet config options
		if ((not (PetExtend_Config[UnitName("pet")])) or (PetExtend_Config[UnitName("pet")].versionLoaded ~= PETEXTEND_VERSION)) then
			PetExtend_Config[UnitName("pet")] = { };
			PetExtend_Config[UnitName("pet")] = PetExtend_DefaultPetConfig;
			
			--Modes
			PetExtend_Config[UnitName("pet")]["Modes"] = {PE_MODE_DEFAULT, PE_MODE_PVP, PE_MODE_TANK};
			PetExtend_Config[UnitName("pet")][PE_MODE_DEFAULT] = {};
			PetExtend_Config[UnitName("pet")][PE_MODE_DEFAULT].note = PE_MODE_STOCK;
			PetExtend_Config[UnitName("pet")][PE_MODE_DEFAULT]["Focus Priority"] = {};
			PetExtend_Config[UnitName("pet")][PE_MODE_DEFAULT]["Skill Management"] = {};
			PetExtend_Config[UnitName("pet")][PE_MODE_PVP] = {};
			PetExtend_Config[UnitName("pet")][PE_MODE_PVP].note = PE_MODE_STOCK;
			PetExtend_Config[UnitName("pet")][PE_MODE_PVP]["Focus Priority"] = {};
			PetExtend_Config[UnitName("pet")][PE_MODE_PVP]["Skill Management"] = {};
			PetExtend_Config[UnitName("pet")][PE_MODE_TANK] = {};
			PetExtend_Config[UnitName("pet")][PE_MODE_TANK].note = PE_MODE_CUSTOM;
			PetExtend_Config[UnitName("pet")][PE_MODE_TANK]["Focus Priority"] = {};
			PetExtend_Config[UnitName("pet")][PE_MODE_TANK]["Skill Management"] = {};
		end
	end
	
end

function PetExtend_Variables_Load()
	--Purpose: Act as a bridge between versions and a loader for new installs. One most add ALL config vars here.

	if ((not (PetExtend_Config)) or (PetExtend_Config.versionLoaded ~= PETEXTEND_VERSION)) then
		PetExtend_Config = {};
		PetExtend_Config = PetExtend_DefaultConfig;
		PetExtend_ConsoleMessage(PE_MESSAGE_LOAD_NEWUSER, "stamped");
	else
		--Assume that this is the correct version; don't do anything but anounce that PetExtend has loaded
		PetExtend_ConsoleMessage(PE_MESSAGE_LOAD_LOADED, "stamped");
	end
	
	local info = {
		icon = "Interface\\Icons\\Ability_Tracking",
		position = -45,
		drag = "CIRCLE",
		left = PetExtend_MinimapButton_OnClick,
		right = PetExtend_MinimapButton_OnClick,
		enabled = 1
	}

	MyMinimapButton:Create("PetExtend", PetExtend_Config.Minimap, info);
	
	if (MyMinimapButton:GetSetting("PetExtend","LOCKED")) then
		MyMinimapButton:SetTooltip("PetExtend", PE_MINIMAP_LOCKED)
	else
		MyMinimapButton:SetTooltip("PetExtend", PE_MINIMAP_UNLOCKED);
	end
	
end

function PetExtend_RegisterEvents(action)
	--Purpose: Either register or unregister the events. This provides a handy way to disable the addon.

	if ((action == "load") and (PetExtend_LoadedEvents == false)) then
		--Register for all events that PetExtend needs
		this:RegisterEvent("ADDON_LOADED");
		this:RegisterEvent("PET_ATTACK_START");
		this:RegisterEvent("PET_ATTACK_STOP");
		this:RegisterEvent("UNIT_HEALTH");
		this:RegisterEvent("UNIT_MANA");
		this:RegisterEvent("UNIT_FOCUS");
		this:RegisterEvent("UNIT_PET");
		this:RegisterEvent("UNIT_NAME_UPDATE");
		this:RegisterEvent("CHAT_MSG_MONSTER_EMOTE");
		this:RegisterEvent("UNIT_AURA");
		parser:RegisterEvent("PetExtend", "CHAT_MSG_COMBAT_PET_HITS", "PetExtend_OnParserEvent");
		parser:RegisterEvent("PetExtend", "CHAT_MSG_SPELL_PET_DAMAGE", "PetExtend_OnParserEvent");
		
		--Set the loaded varible to true, so it knows that the events are loaded.
		PetExtend_LoadedEvents = true;
	elseif ((action == "unload") and (PetExtend_LoadedEvents == true)) then
		--Unregister all events that PetExtend doesn't need anymore
		this:UnregisterEvent("ADDON_LOADED");
		this:UnregisterEvent("PET_ATTACK_START");
		this:UnregisterEvent("PET_ATTACK_STOP");
		this:UnregisterEvent("UNIT_HEALTH");
		this:UnregisterEvent("UNIT_MANA");
		this:UnregisterEvent("UNIT_FOCUS");
		this:UnregisterEvent("UNIT_PET");
		this:UnregisterEvent("UNIT_NAME_UPDATE");
		this:UnregisterEvent("CHAT_MSG_MONSTER_EMOTE");
		this:UnregisterEvent("UNIT_AURA");
		parser:UnregisterAllEvents("PetExtend");
		
		--Set the loaded varible to false, so it knows that the events are not loaded anymore.
		PetExtend_LoadedEvents = false;
	end
	
end


--OnEvent functions
function PetExtend_OnEvent()
	--Purpose: Catch registered events and act upon them.

	if (((event == "ADDON_LOADED") and (arg1 == "PetExtend"))) then
		--Register for myAddons
		if (myAddOnsFrame_Register) then
			myAddOnsFrame_Register(PetExtendDetails)
		end
		
		--Load varibles
		if ((UnitClass("player") == PE_HUNTER) or (UnitClass("player") == PE_WARLOCK)) then
			PetExtend_Variables_Load();
		end
	end
	
	if ((event == "PLAYER_ENTERING_WORLD")) then
		PetExtend_CheckTalents();
	end
	
	if (event == "PET_ATTACK_START") then
		--Flag pet as in combat
		PetExtend_InCombat = true;
		
		--Reset DPS values
		PetExtend_DPS = { };
		
		--Update status frame for the new combat color
		PetExtend_UpdateStatusFrame("background");
	end
	
	if (event == "PET_ATTACK_STOP") then
		--Unflag pet from combat
		PetExtend_InCombat = false;
		
		--Reset DPS values
		PetExtend_DPS = { };
		
		--Update status frame for the new combat color
		PetExtend_UpdateStatusFrame("background");
	end
	
	if (event == "UNIT_HEALTH" and (arg1 == "pet")) then
		--Update the status frame because of the the new health value
		PetExtend_UpdateStatusFrame("health");
		
		--Run the OnHealth script, to moniter pet health and warn if it is below the set percent
		PetExtend_OnPetHealthEvent();
	end
	
	if (event == "UNIT_FOCUS" and (arg1 == "pet")) then
		--Update status frame with the new focus value
		PetExtend_UpdateStatusFrame("mana");
		PetExtend_UpdateStatusFrame("focusindicator");
		PetExtend_UpdateEnhPetBar("mana");
		
		--Run the OnFocus script, which checks the focus management stuff and updates focus indicator
		PetExtend_OnPetFocusEvent();
	end
	
	if (event == "UNIT_MANA" and (arg1 == "pet")) then
		--Update status frame with the new focus value
		PetExtend_UpdateStatusFrame("mana");
		PetExtend_UpdateEnhPetBar("mana");
	end
	
	if (event == "UNIT_PET" and (arg1 == "player")) then
		if ((UnitExists("pet")) and (UnitName("pet") ~= PE_UNKNOWN_ENTITY) and (UnitName("pet") ~= PE_UNKNOWN)) then
			--Run new pet script, which makes the config for the pet
			PetExtend_NewPet();
			PetExtend_UpdateStatusFrame();
		elseif (not UnitExists("pet")) then
			PetExtend_UpdateStatusFrame();
		end
	end
	
	if (event == "UNIT_NAME_UPDATE" and (arg1 == "pet")) then
		if ((UnitExists("pet")) and (UnitName("pet") ~= PE_UNKNOWN_ENTITY) and (UnitName("pet") ~= PE_UNKNOWN)) then
			--Run new pet script, which makes the config for the pet
			PetExtend_NewPet();
			PetExtend_UpdateStatusFrame();
		end
	end
	
	if (event == "CHAT_MSG_MONSTER_EMOTE") then
		--Pass arg1 and arg2 to OnMonsterEmote to check for a running away pet
		PetExtend_OnMonsterEmote(arg1, arg2);
	end
	
end

function PetExtend_OnPetHealthEvent()
	--Purpose: Checks pethealth to see if it is below the onhealth warning and broadcasts a warning.

	if ((PetExtend_Config.partywarn_enable == true) and (PetExtend_Config.partywarn_death == true) and (UnitHealth("pet") == 0)) then
		PetExtend_PartyWarn("death");
		PetExtend_HealthWarned = true;
	elseif ((PetExtend_Config.partywarn_enable == true) and (PetExtend_Config.partywarn_health == true)) then
		--OnHealth is enabled
		if ( (PetExtend_Config.partywarn_healthpercent >= (floor( 100 * UnitHealth("pet") / UnitHealthMax("pet"))) ) and (PetExtend_HealthWarned == false)) then
			--Need to be warned and hasn't been
			PetExtend_PartyWarn("health", (floor( 100 * UnitHealth("pet") / UnitHealthMax("pet"))));
			if ((PetExtend_Config.partywarn_healthAudio == true) and not ((PetExtend_Config.partywarn_healthCalloff == true) and (PetExtend_Config.calloffaudio == true))) then
				PlaySound("igQuestFailed");
			end
			if (PetExtend_Config.partywarn_healthCalloff == true) then
				PetExtend_RegisterCalloff("healthwarning", 5);
			end
			PetExtend_HealthWarned = true;
		elseif ((PetExtend_Config.partywarn_healthpercent < (floor( 100 * UnitHealth("pet") / UnitHealthMax("pet"))) )) then
			PetExtend_HealthWarned = false;
		end
	end
	
end

function PetExtend_OnPetFocusEvent()
	--Purpose: Snag focus regen times and guess at the next ones.

	--Check if pet exists
	if ((UnitExists("pet")) and (not UnitIsDead("pet"))) then
		PetExtend_FocusSample2 = PetExtend_FocusSample1;
		PetExtend_FocusSample1 = UnitMana("pet");
		if (PetExtend_FocusSample1 > PetExtend_FocusSample2) then
			--Focus increased since last reading, must be a regen time; store time and guess next one.
			PetExtend_NextFocusTime = GetTime() + PETEXTEND_FOCUSINTERVAL;
		end
	end
end

function PetExtend_OnMonsterEmote(emote, unit)
	--Purpose: Provides THE functionality for no chase management. Scans emote and registers calloff.

	--Check enable
	if (((UnitExists("pet")) and (not UnitIsDead("pet"))) and (PetExtend_Config.enabled == true) and (PetExtend_Config.nochase == false)) then
		--Scan emote and react if unit is running away in fear
		if ((unit == UnitName("pettarget")) and (UnitHealth("pettarget") < 35) and (strfind(emote, "attempts to run away in fear"))) then
			PetExtend_RegisterCalloff("nochase", 5);
		end
	end
	
end

function PetExtend_OnParserEvent(event, info)
	--Purpose: Provides the functionality for the DPS meter on the status frame.
	--TODO: Don't track DPS if it isn't enabled?
	
	if (info.source == UnitName("pet")) then
		if (info.type == "hit") then
			local damageDone = info.amount;
			local damageTime = GetTime();
			
			tinsert(PetExtend_DPS, damageTime, damageDone);
			
			--Update status frames with new DPS values
			PetExtend_UpdateStatusFrame("dps");
		end
	end
end

function PetExtend_OnUpdate(elapsed)
	--Purpose: Provide a centalized OnUpdate for the entire addon.
	--TODO: Maybe do something else here?

	if (this.TimeSinceLastUpdate == nil) then
		this.TimeSinceLastUpdate = 0;
	end
	
	this.TimeSinceLastUpdate = this.TimeSinceLastUpdate + elapsed;
	
	if (this.TimeSinceLastUpdate > PetExtend_UpdateInterval) then
		--Run the focus OnUpdate;
		PetExtend_Focus_OnUpdate();
		
		this.TimeSinceLastUpdate = 0;
	end
end

function PetExtend_Focus_OnUpdate()
	--Purpose: Check the NextFocusTime for missed regen times and guess the next one.
	--TODO: Find a better way of doing this.

	if (((GetTime() - PetExtend_NextFocusTime) > 0)) then
		-- NextFocusTime expired, fake another one. Hopefully next focus time will provide a real one.
		PetExtend_NextFocusTime = GetTime() + PETEXTEND_FOCUSINTERVAL;
	end
end

function PetExtend_OnChatCommand(msg)
	--Purpose: Just like the OnEvent handler handles events, this handles chat commands.

	--Format msg into command and param
	msg = string.lower(msg);
	local firsti, lasti, command, param = string.find(msg, "(%w+) ([%w%.]+)");
	if ((not command) and msg) then
		command = msg;
	end

	--Help
	if ( (not command) or (command == PE_SLASH_COMMAND_HELP) ) then
		PetExtend_ConsoleMessage(PE_SLASH_MESSAGE_HELPTITLE, "help");
		PetExtend_ConsoleMessage(PE_SLASH_MESSAGE_HELPHELP);
		PetExtend_ConsoleMessage(PE_SLASH_MESSAGE_HELPONOFF);
		PetExtend_ConsoleMessage(PE_SLASH_MESSAGE_HELPGUI);
		PetExtend_ConsoleMessage(PE_SLASH_MESSAGE_HELPRESET);
		PetExtend_ConsoleMessage(PE_SLASH_MESSAGE_HELPSMARTBUTTON);
		PetExtend_ConsoleMessage(PE_SLASH_MESSAGE_HELPREFRESH);
		return;
	end
	
	--On
	if ( command == PE_SLASH_COMMAND_ON ) then
		PetExtend_Config.enabled = true;
		PetExtend_ConfigChange();
		PetExtend_ConsoleMessage(PE_SLASH_MESSAGE_ON, "stamped");
		return;
	end
	
	--Off
	if ( command == PE_SLASH_COMMAND_OFF ) then
		PetExtend_Config.enabled = false;
		PetExtend_ConfigChange();
		PetExtend_ConsoleMessage(PE_SLASH_MESSAGE_OFF, "stamped");
		return;
	end
	
	--Show gui
	if ( command == PE_SLASH_COMMAND_GUI ) then
		PetExtend_MinimapButton_OnClick();
		return;
	end
	
	--Smart Button
	if ( command == PE_SLASH_COMMAND_SMARTBUTTON ) then
		PetExtend_SmartButton();
		return;
	end
	
	--Refresh Focus Management
	if ( command == PE_SLASH_COMMAND_REFRESH ) then
		PetExtend_UpdateAutoCasts();
		return;
	end
	
	--Reset
	if ( command == PE_SLASH_COMMAND_RESET ) then
		PetExtend_ConfigReset();
		PetExtend_ConsoleMessage(PE_SLASH_MESSAGE_RESET, "stamped");
		return;
	end
	
	--Fall out
	PetExtend_ConsoleMessage(PE_SLASH_FALLOUT, "error");
	
end


--Config Functions
function PetExtend_ConfigReset()
	--Purpose: Resets all config varibles to their default state.

	--Enable/disable based on class
	if ((UnitClass("player") == PE_HUNTER) or (UnitClass("player") == PE_WARLOCK)) then
		PetExtend_Config = {};
		PetExtend_Variables_Load();
		PetExtend_NewPet();
	end

end

function PetExtend_ConfigChange()
	--Purpose: Called when PetExtend is enabled or disabled. Unloads events and closes/opens status frame.
	--Todo: Unhook functions here also? Anything else that would be good to get rid of on disable?

	if (PetExtend_Config.enabled == true) then
		--Load events
		PetExtend_RegisterEvents("load");
		
		--Update Status frame to reflect new enable
		PetExtend_UpdateStatusFrame();
	else
		--Unload events
		PetExtend_RegisterEvents("unload");
		
		--Update Status frame to reflect new enable
		PetExtend_UpdateStatusFrame();
	end

end


--Hooked Functions
function PetExtend_PetAttack()
	--Purpose: Hooked PetAttack checks all of PetExtend's onattack stuff and casts them.
	
	if ((PetExtend_Config.enabled == true) and (UnitExists("pet")) and (not UnitIsDead("pet")) and (UnitName("pet") ~= PE_UNKNOWN_ENTITY) and (UnitName("pet") ~= PE_UNKNOWN)) then
		--Clear aggrolist if on
		if (PetExtend_Config.clearAggroList == true) then
			PetFollow();
		end
		
		Pre_PetExtend_PetAttack();
		
		--Run focusconfig if on
		if (PetExtend_Config.focusmanagement == true) then
			PetExtend_UpdateAutoCasts();
		end
		
		--CheckPVP and adjust
		if (PetExtend_Config.pvptaunt == true) then
			if ((PetExtend_CheckPVP())) then
				if (PetExtend_Config[UnitName("pet")].currentmode ~= PE_MODE_PVP) then
					--Switch mode to PvP
					PetExtend_PvPOldMode = PetExtend_Config[UnitName("pet")].currentmode;
					PetExtend_ChangeMode(PE_MODE_PVP);
				end
			else
				if (PetExtend_Config[UnitName("pet")].currentmode == PE_MODE_PVP) then
					if ((PetExtend_PvPOldMode ~= nil) and (PetExtend_Config[UnitName("pet")][PetExtend_PvPOldMode])) then
						PetExtend_ChangeMode(PetExtend_PvPOldMode);
						PetExtend_PvPOldMode = nil;
					else
						PetExtend_ChangeMode(PE_MODE_DEFAULT);
						PetExtend_PvPOldMode = nil;
					end
				end
			end
		end
		
		--On Attack stuff
		if (UnitCanAttack("player", "target")) then
			--Script on attack
			if (PetExtend_Config.scriptOnAttackEnable == true) then
				if (PetExtend_Config.scriptOnAttack ~= "") then
					RunScript(PetExtend_Config.scriptOnAttack);
				end
			end
			
			--Cast spell on attack
			if (PetExtend_Config.attackskillPlayerEnable == true) then
				if (PetExtend_Config.attackskillPlayer ~= nil) then
					local spellName, spellRank = GetSpellName(PetExtend_Config.attackskillPlayer, "spell");
					if (spellName == PE_HUNTERS_MARK) then
						if ((not (PetExtend_MarkOn())) and (UnitCanAttack("player", "target"))) then
							CastSpell(PetExtend_Config.attackskillPlayer, "spell");
						end
					else
						CastSpell(PetExtend_Config.attacksskillPlayer, "spell");
					end
				end
			end
			
			--Cast petskill on attack
			if (PetExtend_Config[UnitName("pet")].attackskillEnable == true) then
				--Cast charge if cooldown allows
				if (PetExtend_Config[UnitName("pet")].attackskill == "Charge") then
					if (PetExtend_PetHasSkill(PE_CHARGE)) then
						if (PetExtend_Config[UnitName("pet")].smartattackskill == true) then
							if (PetExtend_CheckCooldownLeft(PE_CHARGE) == 0) then
								CastPetAction(PetExtend_PetAction[PE_CHARGE].id);
								--Skip dashdive if it's on.
								return;
							end
						else
							if (PetExtend_CheckCooldownLeft(PE_CHARGE) == 0) then
								CastPetAction(PetExtend_PetAction[PE_CHARGE].id);
								--Skip dashdive if it's on.
								return;
							end
						end
					end
				end
				
				--Cast Dash or Dive
				if (PetExtend_Config[UnitName("pet")].dashdive == true) then
					if (PetExtend_PetHasSkill(PE_DASH)) then
						if (PetExtend_Config[UnitName("pet")].smartdashdive == true) then
							if (CheckInteractDistance("pet", 1)) then
								if (CheckInteractDistance("target", 3)) then
									--Too close
								else
									if (PetExtend_CheckCooldownLeft(PE_DASH) == 0) then
										CastPetAction(PetExtend_PetAction[PE_DASH].id);
									end
								end
							end
						else
							if (PetExtend_CheckCooldownLeft(PE_DASH) == 0) then
								CastPetAction(PetExtend_PetAction[PE_DASH].id);
							end
						end
					elseif (PetExtend_PetHasSkill(PE_DIVE)) then
						if (PetExtend_Config[UnitName("pet")].smartdashdive == true) then
							if (CheckInteractDistance("pet", 1)) then
								if (CheckInteractDistance("target", 3)) then
									--Too close
								else
									if (PetExtend_CheckCooldownLeft(PE_DIVE) == 0) then
										CastPetAction(PetExtend_PetAction[PE_DIVE].id);
									end
								end
							end
						else
							if (PetExtend_CheckCooldownLeft(PE_DIVE) == 0) then
								CastPetAction(PetExtend_PetAction[PE_DIVE].id);
							end
						end
					end
				end
				
				--Cast Prowl if cooldown allows
				if (PetExtend_Config[UnitName("pet")].attackskill == "Prowl") then
					if (PetExtend_PetHasSkill("Prowl")) then
						if (PetExtend_Config[UnitName("pet")].smartattackskill == true) then
							if (CheckInteractDistance("pet", 1)) then
								if (CheckInteractDistance("target", 4)) then
									if (PetExtend_CheckCooldownLeft(PE_PROWL) == 0) then
										CastPetAction(PetExtend_PetAction[PE_PROWL].id);
									end
								else
									--Too far away
								end
							else
								if (PetExtend_CheckCooldownLeft(PE_PROWL) == 0) then
									CastPetAction(PetExtend_PetAction[PE_PROWL].id);
								end
							end
						else
							if (PetExtend_CheckCooldownLeft(PE_PROWL) == 0) then
								CastPetAction(PetExtend_PetAction[PE_PROWL].id);
							end
						end
					end
				end
			end
		end
	else
		Pre_PetExtend_PetAttack();
	end
	
end

function PetExtend_UseAction(slot, checkCursor, onSelf)
	--Purpose: The hooked UseAction provides the only place to check and use Scattershot and Feign Death calloff.
	
	if (PetExtend_Config.enabled == true) then
		--Get the cooldown for the spell BEFORE casting
		local start, duration, enable = GetActionCooldown(slot);
		local isUsable, notEnoughMana = IsUsableAction(slot);
		local inRange = IsActionInRange(slot);
		
		-- Call the original function
		Pre_PetExtend_UseAction(slot, checkCursor, onSelf);
		
		--Focus Management call
		PetExtend_UpdateAutoCasts();
		
		--Check for macro's
		if (GetActionText(slot) ~= nil) then
			return;
		end
		
		--Set Tooltip
		PetExtend_Tooltip:ClearLines();
		PetExtend_Tooltip:SetAction(slot);
		
		--Grab the spell name
		local spellName = PetExtend_TooltipTextLeft1:GetText();
		
		--If spellname = accepted and cooldown is down and optionally if in range then do the call off
		if ((spellName == "Scatter Shot") and ((start == 0) and (duration == 0)) and (isUsable == 1) and not (notEnoughMana)) then
			if ((inRange == 1) and (UnitCanAttack("player", "target"))) then
				PetExtend_ScatterShotCalloff();
			end
		elseif ((spellName == "Feign Death") and ((start == 0) and (duration == 0)) and (isUsable == 1) and not (notEnoughMana)) then
			PetExtend_PvPFeignCalloff();
		end
	else
		Pre_PetExtend_UseAction(slot, checkCursor, onSelf);
		return;
	end
	
end

function PetExtend_PetActionBar_Update()
	--Purpose: To update my stuff after blizz does theirs.
	
	Pre_PetExtend_PetActionBar_Update();
	PetExtend_ScanPetBar();
	PetExtend_UpdateEnhPetBar();
end

function PetExtend_CastPetAction(index)
	--Purpose: To make sure that we take care of ALL possiblities regarding the mood lock. Also, updating focus management after this seems like a valid thing to do.

	if (PetExtend_Config.enabled == true) then
		local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(index);
		if (((PetExtend_Config.enhPetBar == true) and (PetExtend_Config.moodManagement == true) and (PetExtend_Config.selectedMood ~= "")) and ((name == "PET_MODE_PASSIVE") or (name == "PET_MODE_AGGRESSIVE") or (name == "PET_MODE_DEFENSIVE"))) then
			if (name ~= PetExtend_Config.selectedMood) then
				local dialog = StaticPopup_Show("PE_SWITCHMOODS_DIALOG");
				if (dialog) then
					dialog.data = name;
				end
				return;
			end
		elseif ((PetExtend_Config.enhPetBar == true) and (name == "PET_ACTION_ATTACK")) then
			PetAttack();
		end
		
		Pre_PetExtend_CastPetAction(index);
		
		PetExtend_UpdateAutoCasts();
	else
		Pre_PetExtend_CastPetAction(index);
		return;
	end
	
end

function PetExtend_TogglePetAutocast(index)
	--Purpose: Update the focus indicator after changing an autocast.
	
	Pre_PetExtend_TogglePetAutocast(index);
	PetExtend_UpdateStatusFrame("focusindicator");
end

function PetExtend_PetActionButton_OnClick(button)
	--Purpose: To make sure that we take care of ALL possiblities regarding the mood lock.
	
	if ((PetExtend_Config.enhPetBar == true) and (PetExtend_Config.moodManagement == true)) then
		this:SetChecked(0);
		if ( IsShiftKeyDown() ) then
			PickupPetAction(this:GetID());
		else
			if ( button == "LeftButton" ) then
				if ( IsPetAttackActive(this:GetID()) ) then
					PetStopAttack();
				else
					CastPetAction(this:GetID());
				end
			else
				local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(this:GetID());
				if ((name == "PET_MODE_PASSIVE") or (name == "PET_MODE_AGGRESSIVE") or (name == "PET_MODE_DEFENSIVE")) then
					if (name ~= PetExtend_Config.selectedMood) then
						PetExtend_Config.selectedMood = name;
						CastPetAction(this:GetID());
					else
						PetExtend_Config.selectedMood = "";
					end
				end
				TogglePetAutocast(this:GetID());
			end
		end
		PetActionBar_Update();
	else
		Pre_PetExtend_PetActionButton_OnClick(button);
	end
end

function PetExtend_PickupSpell(id, bookType)
	--Purpose: Grab the spell id and bookType when a spell is picked up.
	
	Pre_PetExtend_PickupSpell(id, bookType);
	PetExtend_PickedUpSpell = id;
	PetExtend_PickedUpSpellbook = bookType;
end

function PetExtend_PetAggressiveMode()
	--Purpose: To make sure that we take care of ALL possiblities regarding the mood lock.

	if ((PetExtend_Config.enhPetBar == true) and (PetExtend_Config.moodManagement == true) and (PetExtend_Config.selectedMood ~= "")) then
		local name = "PET_MODE_AGGRESSIVE";
		if ((PetExtend_MoodSwitch == true) or (name == PetExtend_Config.selectedMood)) then
			Pre_PetExtend_PetAggressiveMode()
		else
			local dialog = StaticPopup_Show("PE_SWITCHMOODS_DIALOG");
			if (dialog) then
				dialog.data = name;
			end
		end
	else
		Pre_PetExtend_PetAggressiveMode()
	end
	
end

function PetExtend_PetDefensiveMode()
	--Purpose: To make sure that we take care of ALL possiblities regarding the mood lock.

	if ((PetExtend_Config.enhPetBar == true) and (PetExtend_Config.moodManagement == true)) then
		local name = "PET_MODE_DEFENSIVE";
		if ((PetExtend_MoodSwitch == true) or (name == PetExtend_Config.selectedMood)) then
			Pre_PetExtend_PetDefensiveMode()
		else
			local dialog = StaticPopup_Show("PE_SWITCHMOODS_DIALOG");
			if (dialog) then
				dialog.data = name;
			end
		end
	else
		Pre_PetExtend_PetDefensiveMode()
	end
	
end

function PetExtend_PetPassiveMode()
	--Purpose: To make sure that we take care of ALL possiblities regarding the mood lock.

	if ((PetExtend_Config.enhPetBar == true) and (PetExtend_Config.moodManagement == true)) then
		local name = "PET_MODE_PASSIVE";
		if ((PetExtend_MoodSwitch == true) or (name == PetExtend_Config.selectedMood)) then
			Pre_PetExtend_PetPassiveMode()
		else
			local dialog = StaticPopup_Show("PE_SWITCHMOODS_DIALOG");
			if (dialog) then
				dialog.data = name;
			end
		end
	else
		Pre_PetExtend_PetPassiveMode()
	end
	
end


--Update Functions
function PetExtend_UpdateEnhPetBar(update)
	--Purpose: Provide a clean way to update the enhanced pet bar.
	--TODO: Maybe check a few more things here before just blindly updating.
	
	if (update == "mana") then
		if ((PetExtend_Config.enhPetBar == true)and (PetExtend_Config.enhPetBarShade == true)) then
			for i=1, NUM_PET_ACTION_SLOTS, 1 do
				local petActionIcon = getglobal("PetActionButton"..i.."Icon");
				local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);
				if (name ~= nil) then
					if (PetExtend_PetAction[name]) then
						if ((UnitMana("pet") - PetExtend_PetAction[name].cost) < 0) then
							petActionIcon:SetVertexColor(.4, .4, 1);
						else
							petActionIcon:SetVertexColor(1, 1, 1);
						end
					end
				end
			end
		end
	elseif (update == "cooldown") then
	
	elseif (update == "moods") then
		if ((PetExtend_Config.enhPetBar == true) and (PetExtend_Config.moodManagement == true)) then
			for i=1, NUM_PET_ACTION_SLOTS, 1 do
				local petAutoCastableTexture = getglobal("PetActionButton"..i.."AutoCastable");
				local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);
				if (name ~= nil) then
					if ((name == PetExtend_Config.selectedMood)) then
						petAutoCastableTexture:Show();
					end
				end
			end
		end
	else
		PetExtend_UpdateEnhPetBar("mana");
		PetExtend_UpdateEnhPetBar("cooldown");
		PetExtend_UpdateEnhPetBar("moods");
	end
end

function PetExtend_UpdateStatusFrame(update)
	--Purpose: Allows a easy to call status frame updater.
	
	--Hide or show and then continue or not
	if ((PetExtend_Config.enabled == false) or (PetExtend_Config.status == false) or ((not  UnitExists("pet") ) or (UnitIsDead("pet"))) or (PetExtend_Config.statusScale <= 0)) then
		PetExtend_StatusFrame:Hide();
		return;
	else
		PetExtend_StatusFrame:Show();
	end
	
	if (update == "background") then
		--Set Color based on combat status
		if ((PetExtend_InCombat == false)) then
			PetExtend_StatusFrame:SetBackdropColor(0, 0.1, 0.9, 0.75);
		else
			PetExtend_StatusFrame:SetBackdropColor(0.9, 0.1, 0, 0.75);
		end
	elseif (update == "health") then
		if (PetExtend_Config.statusHealthBar == true) then
			PetExtend_HealthBar:Show();
			PetExtend_HealthBar:SetMinMaxValues(0, UnitHealthMax("pet"));
			PetExtend_HealthBar:SetValue(UnitHealth("pet"));
			if (PetExtend_Config.statusLabels == true) then
				PetExtend_HealthPlate:Show();
				PetExtend_HealthPlate:SetText(UnitHealth("pet").." / "..UnitHealthMax("pet"))
			else
				PetExtend_HealthPlate:Hide();
			end
		else
			PetExtend_HealthBar:Hide();
			--SIZE FRAME
		end
	elseif (update == "mana") then
		if (PetExtend_Config.statusFocusBar == true) then
			PetExtend_ManaBar:Show();
			if (UnitPowerType("pet") == 2) then
				PetExtend_ManaBar:SetStatusBarColor(1, .50, .25, 1);
			elseif (UnitPowerType("pet") == 0) then
				PetExtend_ManaBar:SetStatusBarColor(0, 0, 1, 1);
			end
			PetExtend_ManaBar:SetMinMaxValues(0, UnitManaMax("pet"));
			PetExtend_ManaBar:SetValue(UnitMana("pet"));
			if (PetExtend_Config.statusLabels == true) then
				PetExtend_ManaPlate:Show();
				PetExtend_ManaPlate:SetText(UnitMana("pet").." / "..UnitManaMax("pet"))
			else
				PetExtend_ManaPlate:Hide();
			end
		else
			PetExtend_ManaBar:Hide();
			--SIZE FRAME
		end
	elseif (update == "mode") then
		if (PetExtend_Config.statusMode == true) then
			PetExtend_ModePlate:Show();
			if ((UnitName("pet") ~= PE_UNKNOWN_ENTITY) and (UnitName("pet") ~= PE_UNKNOWN) and (PetExtend_Config[UnitName("pet")])) then
				PetExtend_ModePlate:SetText(PetExtend_Config[UnitName("pet")].currentmode);
			end
		else
			PetExtend_ModePlate:Hide();
			--SIZE FRAME
		end
	elseif (update == "name") then
		if (PetExtend_Config.statusName == true) then
			PetExtend_NamePlate:Show();
			PetExtend_NamePlate:SetText(UnitName("pet")..":");
		else
			PetExtend_NamePlate:Hide();
			--SIZE FRAME
		end
	elseif (update == "dps") then
		if (PetExtend_Config.statusDPS == true) then
			PetExtend_DPSPlate:Show();
			
			--*cough* I hope this works!
			if (PetExtend_InCombat == true) then
				local damage = 0;
				local maxTime = 0;
				table.foreach(PetExtend_DPS, function(damageTime, damageValue) 
					if (GetTime() - damageTime <= 15) then
						damage = damage + damageValue;
						if ((maxTime == 0) or (damageTime < maxTime)) then
							maxTime = damageTime;
						end

					end
				end);
				
				local combatTime = (GetTime() - maxTime);
				
				PetExtend_DPSPlate:SetText((floor((damage / combatTime) * 10)) / 10);
			else
				if ((PetExtend_DPSPlate:GetText() == "") or (PetExtend_DPSPlate:GetText() == "0")) then
					PetExtend_DPSPlate:SetText("DPS");
				end
			end
		else
			PetExtend_DPSPlate:Hide();
		end
	elseif (update == "focusindicator") then
		if ((PetExtend_Config.statusFocusIndicator == true)) then
			PetExtend_UpdateFocusIndicator();
		else
			PetExtend_FocusIndicator:Hide();
		end
	elseif (update == "scale") then
		PetExtend_StatusFrame:SetScale((PetExtend_Config.statusScale / 100));
	else
		PetExtend_UpdateStatusFrame("background");
		PetExtend_UpdateStatusFrame("health");
		PetExtend_UpdateStatusFrame("mana");
		PetExtend_UpdateStatusFrame("mode");
		PetExtend_UpdateStatusFrame("name");
		PetExtend_UpdateStatusFrame("dps");
		PetExtend_UpdateStatusFrame("scale");
		PetExtend_UpdateStatusFrame("focusindicator");
	end
end

function PetExtend_UpdateFocusIndicator()
	--Purpose: Shows and hides the Focus Indicator to signal the need for a focus refresh.

	if ((UnitExists("pet")) and (UnitName("pet") ~= PE_UNKNOWN_ENTITY) and (UnitName("pet") ~= PE_UNKNOWN)) then
		local needsUpdate = false;
		
		--Update focus management
		if (PetExtend_Config.focusmanagement == true) then
			for i=1, getn(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"]) do
				local skill = PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"][i];
				if (PetExtend_FocusSkillCheck(skill) == "IGNORE_AUTOCAST") then
					--Nothing needs to be done
				else
					needsUpdate = true;
				end
			end
		end
		
		--Update skill management
		if (PetExtend_Config.skillmanagement == true) then
			for i=1, getn(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"]) do
				local skill = PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"][i];
				if (PetExtend_SkillManagementCheck(skill) == "IGNORE_AUTOCAST") then
					--Nothing needs to be done
				else
					needsUpdate = true;
				end
			end
		end
		
		--Hide or show focus indicator to match information gathered
		if ((needsUpdate == true) and (PetExtend_FocusIndicator:GetAlpha() == 0)) then
			PetExtend_FocusIndicator:Show();
			UIFrameFadeIn(PetExtend_FocusIndicator, .3);
		elseif ((needsUpdate == false) and (PetExtend_FocusIndicator:GetAlpha() == 1)) then
			UIFrameFadeOut(PetExtend_FocusIndicator, .3);
		end
		
	end
end


--SmartButton Functions
function PetExtend_SmartButton()
	--Purpose: The Smart Button. Provides a nice macro-like thing to user.
	
	PetExtend_UpdateAutoCasts();
	
	if ((PetExtend_SmartButton_ClickTime ~= 0) and ((GetTime() - PetExtend_SmartButton_ClickTime) <= DOUBLECLICK_TIME)) then
		PetExtend_SmartButton_ClickTime = 0;
		if ((PetExtend_Config.debuffcheck == true) and (PetExtend_BreakableDebuffCheck())) then
			--Break debuff
			PetAttack();
			if (PetExtend_Config.partywarn_style ~= "") then
				PetExtend_PartyWarn("breakdebuff");
			end
			return;
		else
			PetFollow();
			PetExtend_UpdateStatusFrame();
			return;
		end
	else
		PetExtend_SmartButton_ClickTime = GetTime();
	end
	
	--Check calloff
	if ((PetExtend_SmartButton_CallOff ~= 0) and (PetExtend_SmartButton_CallOff >= GetTime()))then
		PetFollow();
		PetExtend_SmartButton_CallOff = 0;
		return;
	else
		PetExtend_SmartButton_CallOff = 0;
	end
	
	--Standard smartpet smartbutton: attack enemy, assist friendly, follow if pet doesn't exist.
	if (UnitExists("target") and (not (UnitIsDead("target")))) then
		--Attack enemy
		if ((UnitCanAttack("player", "target")) and not (UnitIsUnit("target", "pettarget")) and not (UnitIsDead("targettarget"))) then
			--Debuff check
			if ((PetExtend_Config.debuffcheck == true) and (PetExtend_BreakableDebuffCheck())) then
				--Debuff check failed, chat alert
				UIErrorsFrame:AddMessage("Debuff check failed, not sending pet.", 1.0, 0.0, 0.0, 1.0, 2.5);
			else
				--Debuff check is off or passed, attack w/ attack phrase
				PetAttack();
				PetExtend_PartyWarn("attack");
			end
			
		--Assist Friend
		elseif ((UnitCanAssist("player", "target")) and (UnitIsEnemy("player", "targettarget")) and not (UnitIsDead("targettarget")) and not (UnitIsUnit("targettarget", "pettarget"))) then
			--Assist target
			AssistUnit("target");
			
			--Debuff check
			if ((PetExtend_Config.debuffcheck == true) and (PetExtend_BreakableDebuffCheck())) then
				--Debuff check failed, chat alert
				UIErrorsFrame:AddMessage("Debuff check failed, not sending pet.", 1.0, 0.0, 0.0, 1.0, 2.5);
			else
				--Debuff check is off or passed, attack w/ attack phrase
				PetExtend_PetAttack();
				PetExtend_PartyWarn("assist");
			end
		end
	else
		--If no target is selected, then PetFollow
		PetFollow();
	end
	
	--Update frame
	PetExtend_UpdateStatusFrame();
	
end

function PetExtend_PartyWarn(message, other)
	--Purpose: Warns pary based on message and style of PartyWarn.
	--TODO: Improve and localize!!!

	--Check enable
	if ((PetExtend_Config.enabled == true) and (PetExtend_Config.partywarn_enable == true) and (UnitExists("pet"))) then
		--Local vars
		local pet = UnitName("pet");
		local target = UnitName("target");
		local output = "";
		
		if ((message == "attack") and (PetExtend_Config.partywarn_attack == true)) then
			if (PetExtend_Config.partywarn_style == "RP") then
				local PetExtend_Attack_Target = {
					pet.."! Attack the "..target.."!",
					"Attack the "..target..", "..pet.."!",
					"Kill the " ..target..", "..pet.."!",
					pet.."! Sic the "..target.."!" 
				};
				output = PetExtend_Attack_Target[math.random(table.getn(PetExtend_Attack_Target))];
			else
				output = "[PetExtend]: "..pet.." is attacking "..target..".";
			end
		elseif ((message == "assist") and (PetExtend_Config.partywarn_assist == true)) then
			if (PetExtend_Config.partywarn_style == "RP") then
				local PetExtend_Assist_Player = {
					pet.."! Assist "..target.."!",
					pet.."! Aid "..target.."!",
					pet.."! Help "..target.."!",
					pet.."! "..target.."needs your help!"
				};
				output = PetExtend_Assist_Target[math.random(table.getn(PetExtend_Assist_Target))];
			else
				output = "[PetExtend]: "..pet.." is assisting "..target..".";
			end
		elseif ((message == "death") and (PetExtend_Config.partywarn_death == true)) then
			if (PetExtend_Config.partywarn_style == "RP") then
				local PetExtend_Pet_Death = {
					pet.."! No!",
					pet.."'s dead, Jim.",
					"Dangit! "..pet.." died.",
					pet.."! Don't die on me now! NO!"
				};
				output = PetExtend_Assist_Target[math.random(table.getn(PetExtend_Pet_Death))];
			else
				output = "[PetExtend]: "..pet.." ("..UnitName("player").."'s pet) is dead.";
			end
		elseif ((message == "health") and (PetExtend_Config.partywarn_health == true)) then
			if (PetExtend_Config.partywarn_style == "RP") then
				local PetExtend_Pet_Health = {
					pet.."! Keep fighting 'til the death!",
					"Someone throw "..pet.." a heal!",
					"Oh my gosh! "..pet.." is about to die!",
					pet.."! Don't die on me now!"
				};
				output = PetExtend_Assist_Target[math.random(table.getn(PetExtend_Pet_Health))];
			else
				output = "[PetExtend]: "..pet.." ("..UnitName("player").."'s pet) is at "..other.."%!";
			end
		end
		
		if (output ~= "") then
			if (PetExtend_Config.partywarn_warning_channel == "Console") then
				PetExtend_ConsoleMessage(output, "stamped")
			elseif (PetExtend_Config.partywarn_warning_channel == "Say") then
				SendChatMessage(output, "SAY");
			elseif (PetExtend_Config.partywarn_warning_channel == "Party") then
				SendChatMessage(output, "PARTY");
			elseif (PetExtend_Config.partywarn_warning_channel == "Raid") then
				SendChatMessage(output, "RAID");
			elseif (PetExtend_Config.partywarn_warning_channel == "Smart") then
				if (GetNumRaidMembers() > 0) then
					SendChatMessage(output, "RAID");
				elseif (UnitInParty("party1")) then
					SendChatMessage(output, "PARTY");
				else
					SendChatMessage(output, "SAY");
				end
			end
		end
	end
	
	
end


--Focus Functions
function PetExtend_UpdateAutoCasts()
	--Purpose: Easy way to update all autocasts. Successor to PetExtend_UpdateAutoCasts(), it supports the new SkillManagememt.
	
	if ((UnitExists("pet")) and (UnitName("pet") ~= PE_UNKNOWN_ENTITY) and (UnitName("pet") ~= PE_UNKNOWN)) then
		
		--Update focus management
		if (PetExtend_Config.focusmanagement == true) then
			for i=1, getn(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"]) do
				local skill = PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"][i];
				if (PetExtend_FocusSkillCheck(skill) == "IGNORE_AUTOCAST") then
					--Nothing needs to be done
				elseif (PetExtend_FocusSkillCheck(skill) == "DISABLE_AUTOCAST") then
					PetExtend_DisableAutoCast(skill);
				elseif (PetExtend_FocusSkillCheck(skill) == "ENABLE_AUTOCAST") then
					PetExtend_EnableAutoCast(skill);
				end
			end
		end
		
		--Update skill management
		if (PetExtend_Config.skillmanagement == true) then
			for i=1, getn(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"]) do
				local skill = PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"][i];
				
				if (PetExtend_SkillManagementCheck(skill) == "IGNORE_AUTOCAST") then
					--Nothing needs to be done
				elseif (PetExtend_SkillManagementCheck(skill) == "DISABLE_AUTOCAST") then
					PetExtend_DisableAutoCast(skill);
				elseif (PetExtend_SkillManagementCheck(skill) == "ENABLE_AUTOCAST") then
					PetExtend_EnableAutoCast(skill);
				end
			end
		end
		
		PetExtend_UpdateStatusFrame("focusindicator");
	end
end

function PetExtend_FocusSkillCheck(skill)
	--Purpose: Checks to see if a skill needs a refresh for focus purposes.
	
	--Check if pet exists
	if ((UnitExists("pet")) and (UnitName("pet") ~= PE_UNKNOWN_ENTITY) and (UnitName("pet") ~= PE_UNKNOWN)) then
		if (PetExtend_IsSkillInFocusPriority(skill)) then
			local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(PetExtend_PetAction[skill].id);
			local availableFocus = UnitMana("pet");
			local consumedFocus;
			
			for p=1, getn(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"]) do
				local s = PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"][p];
				
				if (s == skill) then
					if (availableFocus >= 0) then
						--focus available for skill
						if not (autoCastEnabled) then
							return "ENABLE_AUTOCAST";
						else
							return "IGNORE_AUTOCAST";
						end
					else
						--no focus available for skill
						if (autoCastEnabled) then
							return "DISABLE_AUTOCAST";
						else
							return "IGNORE_AUTOCAST";
						end
					end
				else
					if ((PetExtend_PetAction[s].cost) and (PetExtend_FocusRegen(s))) then
						consumedFocus = ((PetExtend_PetAction[s].cost) - (PetExtend_FocusRegen(s)));
						if (consumedFocus < 0) then
							--going to regen more then cost
							consumedFocus = 0;
						end
						availableFocus = availableFocus - consumedFocus;
					end
				end
			end
		else
			return "IGNORE_AUTOCAST";
		end
	end
end

function PetExtend_SkillManagementCheck(skill)
	--Purpose: Checks to see if any pet skills are disabled.

	--Check if pet exists
	if ((UnitExists("pet")) and (UnitName("pet") ~= PE_UNKNOWN_ENTITY) and (UnitName("pet") ~= PE_UNKNOWN)) then
		if (PetExtend_IsSkillInSkillManagement(skill)) then
			local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(PetExtend_PetAction[skill].id);
			
			for i=1, getn(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"]) do
				local s = PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"][i];
				
				if (s == skill) then
					if (PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"][i.."alwaysenable"]) then
						if not (autoCastEnabled) then
							return "ENABLE_AUTOCAST";
						else
							return "IGNORE_AUTOCAST";
						end
					elseif (PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"][i.."alwaysdisable"]) then
						if (autoCastEnabled) then
							return "DISABLE_AUTOCAST";
						else
							return "IGNORE_AUTOCAST";
						end
					else
						return "IGNORE_AUTOCAST";
					end
				end
			end
		else
			return "IGNORE_AUTOCAST";
		end
	end
	
end


--Bindings
function PetExtend_Binding_Action(action)
	--Purpose: Provides a way for the user to control pet actions.
	--Notes: Thanks go out to Snidely for helping with this code!

	--Save double click time and act upon the old one.
	if ((PetExtend_BindingAction_ClickTimes[action] ~= 0) and ((GetTime() - PetExtend_BindingAction_ClickTimes[action]) <= DOUBLECLICK_TIME)) then
		--Double Click State
		local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo((action + 3));
		if ((name ~= nil) and not (autoCastEnabled)) then
			TogglePetAutocast((action + 3));
		end
		PetExtend_BindingAction_ClickTimes[action] = 0; --reset state table to single click state
	else
		--Single Click State
		-- scan petaction and either  set autocast off or cast the action.
		local startTime, duration, enable = GetPetActionCooldown((action + 3));
		local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo((action + 3));
		if ((name ~= nil) and (autoCastEnabled)) then
			TogglePetAutocast((action + 3));
			PetExtend_BindingAction_ClickTimes[action] = 0; --reset state table to single click state
		elseif ((name ~= nil) and (startTime == 0)) then
			CastPetAction((action + 3));
			PetExtend_BindingAction_ClickTimes[action] = GetTime(); -- set up for transition to double click state
		else
			PetExtend_BindingAction_ClickTimes[action] = GetTime();
		end
	end
end

function PetExtend_Binding_SmartButton_Mouseover()
	if ((UnitExists("mouseover")) and (UnitExists("target"))) then
		TargetUnit("mouseover");
		PetExtend_SmartButton();
		TargetLastTarget();
	elseif (UnitExists("mouseover")) then
		TargetUnit("mouseover");
		PetExtend_SmartButton();
	end
end


function PetExtend_MinimapButton_OnClick()

	if (not PetExtend_GUIFrame:IsVisible()) then
		PetExtend_GUITab_OnClick(1);
		PetExtend_GUIFrame:Show();
	else
		PetExtend_GUIFrame:Hide();
	end
end

