--PetExtend.GUI.lua
--Holds all GUI functions and methods.


function PetExtend_GUITab_OnClick(id)
	
	--Pet Only tab
	if ((id == 4) and ((UnitName("pet") == nil) or (UnitName("pet") == PE_UNKNOWN_ENTITY) or (UnitName("pet") == PE_UNKNOWN))) then
		PetExtend_ConsoleMessage(PE_MESSAGE_ERROR_NOPET, "error");
		local TabName = getglobal("PetExtend_Tab"..id);
		TabName:SetChecked(nil);
		return;
	end
	
	local TabName;
	for index = 1, 5, 1 do
		TabName = getglobal("PetExtend_Tab"..index);
		if (index == id) then
			TabName:SetChecked(1);
		else
			TabName:SetChecked(nil);
		end
	end
	
	PetExtend_ScanPetBar();
	
	if (id == 1) then
		ShowUIPanel(PetExtend_Tab1_Menu);
		HideUIPanel(PetExtend_Tab2_Menu);
		HideUIPanel(PetExtend_Tab3_Menu);
		HideUIPanel(PetExtend_Tab4_Menu);
		HideUIPanel(PetExtend_Tab5_Menu);
		PetExtend_CircleIcon:SetTexture("Interface\\FriendsFrame\\FriendsFrameScrollIcon");
		PetExtend_PageText:SetText(PE_GUI_TAB1);
	elseif (id == 2) then
		HideUIPanel(PetExtend_Tab1_Menu);
		ShowUIPanel(PetExtend_Tab2_Menu);
		HideUIPanel(PetExtend_Tab3_Menu);
		HideUIPanel(PetExtend_Tab4_Menu);
		HideUIPanel(PetExtend_Tab5_Menu);
		PetExtend_CircleIcon:SetTexture("Interface\\FriendsFrame\\FriendsFrameScrollIcon");
		PetExtend_PageText:SetText(PE_GUI_TAB2);
	elseif (id == 3) then
		HideUIPanel(PetExtend_Tab1_Menu);
		HideUIPanel(PetExtend_Tab2_Menu);
		ShowUIPanel(PetExtend_Tab3_Menu);
		HideUIPanel(PetExtend_Tab4_Menu);
		HideUIPanel(PetExtend_Tab5_Menu);
		PetExtend_CircleIcon:SetTexture("Interface\\FriendsFrame\\FriendsFrameScrollIcon");
		PetExtend_PageText:SetText(PE_GUI_TAB3);
	elseif (id == 4) then
		HideUIPanel(PetExtend_Tab1_Menu);
		HideUIPanel(PetExtend_Tab2_Menu);
		HideUIPanel(PetExtend_Tab3_Menu);
		ShowUIPanel(PetExtend_Tab4_Menu);
		HideUIPanel(PetExtend_Tab5_Menu);
		PetExtend_CircleIcon:SetTexture("Interface\\FriendsFrame\\FriendsFrameScrollIcon");
		PetExtend_PageText:SetText(PE_GUI_TAB4);
	elseif (id == 5) then
		HideUIPanel(PetExtend_Tab1_Menu);
		HideUIPanel(PetExtend_Tab2_Menu);
		HideUIPanel(PetExtend_Tab3_Menu);
		HideUIPanel(PetExtend_Tab4_Menu);
		ShowUIPanel(PetExtend_Tab5_Menu);
		PetExtend_CircleIcon:SetTexture("Interface\\FriendsFrame\\FriendsFrameScrollIcon");
		PetExtend_PageText:SetText(PE_GUI_TAB5);
	end
end


function PetExtend_Checkbox_Enable(checkBox, text)
	checkBox:Enable();
	getglobal(checkBox:GetName().."Text"):SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	if (text) then
		getglobal(checkBox:GetName().."Text"):SetText(text);
	end
end

function PetExtend_Checkbox_Disable(checkBox, text)
	checkBox:Disable();
	getglobal(checkBox:GetName().."Text"):SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
	if (text) then
		getglobal(checkBox:GetName().."Text"):SetText(text);
	end
end

function PetExtend_Checkbox_OnShow(variable)
	
	if (variable == true) then
		this:SetChecked(true);
	else
		this:SetChecked(nil);
	end
	
end


function PetExtend_PlayerAttackSkill_Button_OnClick()

	if (((PetExtend_PickedUpSpell ~= "") and (CursorHasSpell())) and (PetExtend_PickedUpSpellbook == "spell")) then
		local spellName, spellRank = GetSpellName(PetExtend_PickedUpSpell, PetExtend_PickedUpSpellbook);
		PetExtend_PlayerAttackSkill_Button:SetNormalTexture(GetSpellTexture(PetExtend_PickedUpSpell, PetExtend_PickedUpSpellbook));
		ResetCursor();
		
		PetExtend_Config.attackskillPlayer = PetExtend_PickedUpSpell;
		PetExtend_PickedUpSpell = "";
		PetExtend_PickedUpSpellbook = "";
		PetExtend_PlayerAttackSkill_FontString:SetText(spellName.." "..spellRank);
	end
	
end

function PetExtend_PlayerAttackSkill_Button_OnDragStart()

	PetExtend_PlayerAttackSkill_Button:SetNormalTexture("Interface\\Buttons\\UI-EmptySlot-Disabled");
	if (PetExtend_Config.attackskillPlayer ~= nil) then
		PickupSpell(PetExtend_Config.attackskillPlayer, "spell");
		PetExtend_Config.attackskillPlayer = nil;
		PetExtend_PlayerAttackSkill_FontString:SetText(PE_GUI_TAB2_PLAYERATTACKSKILLNONE);
	end
	
end

function PetExtend_PlayerAttackSkill_Button_OnReceiveDrag()

	if (((PetExtend_PickedUpSpell ~= "") and (CursorHasSpell())) and (PetExtend_PickedUpSpellbook == "spell")) then
		local spellName, spellRank = GetSpellName(PetExtend_PickedUpSpell, PetExtend_PickedUpSpellbook);
		PetExtend_PlayerAttackSkill_Button:SetNormalTexture(GetSpellTexture(PetExtend_PickedUpSpell, PetExtend_PickedUpSpellbook));
		ResetCursor();
		
		PetExtend_Config.attackskillPlayer = PetExtend_PickedUpSpell;
		PetExtend_PickedUpSpell = "";
		PetExtend_PickedUpSpellbook = "";
		PetExtend_PlayerAttackSkill_FontString:SetText(spellName.." "..spellRank);
	end
	
end

function PetExtend_PlayerAttackSkill_Button_OnShow()

	if (PetExtend_Config.attackskillPlayer ~= nil) then
		PetExtend_PlayerAttackSkill_Button:SetNormalTexture(GetSpellTexture(PetExtend_Config.attackskillPlayer, "spell"));
		local spellName, spellRank = GetSpellName(PetExtend_Config.attackskillPlayer, "spell");
		PetExtend_PlayerAttackSkill_FontString:SetText(spellName.." "..spellRank);
	else
		PetExtend_PlayerAttackSkill_FontString:SetText(PE_GUI_TAB2_PLAYERATTACKSKILLNONE);
	end
	
end


function PetExtend_DNAScrollBar_Update()
	
	local maxEntries = getn(PetExtend_Config.DoNotAttackList);
	local displayedLines = 5;
	local lineHeight = 16;
	
	FauxScrollFrame_Update(PetExtend_DNAScrollBar, maxEntries, displayedLines, lineHeight);
	
	local line; -- 1 through 5 of our window to scroll
	local lineplusoffset; -- an index into our data calculated from the scroll offset
	for line = 1, displayedLines do
		lineplusoffset = line + FauxScrollFrame_GetOffset(PetExtend_DNAScrollBar);
		if ((lineplusoffset <= maxEntries)) then
			getglobal("PetExtend_DNAEntry"..line.."_Text"):SetText(PetExtend_Config.DoNotAttackList[lineplusoffset]);
			getglobal("PetExtend_DNAEntry"..line):Show();
			if ((PetExtend_SelectedDNAEntry ~= nil) and (lineplusoffset == PetExtend_SelectedDNAEntry)) then
				getglobal("PetExtend_DNAEntry"..line):LockHighlight();
			else
				getglobal("PetExtend_DNAEntry"..line):UnlockHighlight();
			end
		else
			getglobal("PetExtend_DNAEntry"..line):Hide();
		end
	end
	
end

function PetExtend_DNA_AddEntry(entry)

	if (entry ~= "") then
		tinsert(PetExtend_Config.DoNotAttackList, entry);
	end
	
	PetExtend_DNAScrollBar_Update();
	
end

function PetExtend_DNA_SelectEntry(id)

	local idPlusOffset = id + FauxScrollFrame_GetOffset(PetExtend_DNAScrollBar);
	PetExtend_SelectedDNAEntry = idPlusOffset;
	PetExtend_DNAScrollBar_Update();
end

function PetExtend_DNS_RemoveEntry()

	if (PetExtend_SelectedDNAEntry ~= nil) then
		tremove(PetExtend_Config.DoNotAttackList, PetExtend_SelectedDNAEntry)
	end
	
	PetExtend_DNAScrollBar_Update();
end


function PetExtend_ModeScrollBar_Update()

	local maxEntries = getn(PetExtend_Config[UnitName("pet")]["Modes"]);
	local displayedLines = 3;
	local lineHeight = 32;
	
	FauxScrollFrame_Update(PetExtend_ModeScrollBar, maxEntries, displayedLines, lineHeight);
	
	local line; -- 1 through 5 of our window to scroll
	local lineplusoffset; -- an index into our data calculated from the scroll offset
	for line = 1, displayedLines do
		lineplusoffset = line + FauxScrollFrame_GetOffset(PetExtend_ModeScrollBar);
		if ((lineplusoffset <= maxEntries)) then
			getglobal("PetExtend_ModeEntry"..line.."_TitleText"):SetText(PetExtend_Config[UnitName("pet")]["Modes"][lineplusoffset]);
			getglobal("PetExtend_ModeEntry"..line.."_SubtitleText"):SetText(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")]["Modes"][lineplusoffset]].note);
			getglobal("PetExtend_ModeEntry"..line):Show();
			
			if (PetExtend_Config[UnitName("pet")]["Modes"][lineplusoffset] == PetExtend_Config[UnitName("pet")].currentmode) then
				getglobal("PetExtend_ModeEntry"..line):LockHighlight();
			else
				getglobal("PetExtend_ModeEntry"..line):UnlockHighlight();
			end
			
		else
			getglobal("PetExtend_ModeEntry"..line):Hide();
		end
	end
	
end

function PetExtend_ModeScrollBar_SelectEntry(id)

	local idPlusOffset = id + FauxScrollFrame_GetOffset(PetExtend_ModeScrollBar);
	PetExtend_ChangeMode(PetExtend_Config[UnitName("pet")]["Modes"][idPlusOffset]);
	
end

function PetExtend_AddMode(entry)

	if (entry ~= "") then
		tinsert(PetExtend_Config[UnitName("pet")]["Modes"], entry);
		PetExtend_Config[UnitName("pet")][entry] = {};
		PetExtend_Config[UnitName("pet")][entry].note = PE_MODE_CUSTOM;
		PetExtend_Config[UnitName("pet")][entry]["Focus Priority"] = {};
		PetExtend_Config[UnitName("pet")][entry]["Skill Management"] = {};
	end
	
	PetExtend_ModeScrollBar_Update();
	
end

function PetExtend_RemoveMode()

	if (PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode].note == PE_MODE_CUSTOM) then
		local modeIndex;
		for i=1, getn(PetExtend_Config[UnitName("pet")]["Modes"]), 1 do
			if ((PetExtend_Config[UnitName("pet")]["Modes"][i] == PetExtend_Config[UnitName("pet")].currentmode)) then
				modeIndex = i;
			end
		end
		
		tremove(PetExtend_Config[UnitName("pet")]["Modes"], modeIndex);
		PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode] = nil;
		
		PetExtend_ChangeMode(PE_MODE_DEFAULT);
		
	end
end


function PetExtend_Update_FocusManagement()
	
	local line;
	for line = 1, 4 do
		if (PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"][line]) then
			getglobal("PetExtend_FocusManagementEntry"..line.."_LeftText"):SetText(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"][line]);
			getglobal("PetExtend_FocusManagementEntry"..line):Show();
			
			if ((PetExtend_SelectedFocusEntry ~= nil) and (line == PetExtend_SelectedFocusEntry)) then
				getglobal("PetExtend_FocusManagementEntry"..line):LockHighlight();
			else
				getglobal("PetExtend_FocusManagementEntry"..line):UnlockHighlight();
			end
		else
			getglobal("PetExtend_FocusManagementEntry"..line):Hide();
		end
	end
end

function PetExtend_Select_FocusManagement(id)
	
	PetExtend_SelectedFocusEntry = id;
	PetExtend_SelectedSkillEntry = nil;
	PetExtend_Update_FocusManagement();
	PetExtend_Update_SkillManagement();
	
end

function PetExtend_FocusManagement_MoveUp()
	
	if ((PetExtend_SelectedFocusEntry ~= nil) and (PetExtend_SelectedSkillEntry == nil)) then
		local position = PetExtend_SelectedFocusEntry - 1;
		local skill = PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"][PetExtend_SelectedFocusEntry];
		
		if ((skill ~= nil) and (position >= 1)) then
			tremove(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"], PetExtend_SelectedFocusEntry);
			tinsert(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"], position, skill);
			PetExtend_SelectedFocusEntry = position;
		end
	end
	
	PetExtend_Update_FocusManagement();
	PetExtend_Update_SkillManagement();
	
end

function PetExtend_FocusManagement_MoveDown()
	
	if ((PetExtend_SelectedFocusEntry ~= nil) and (PetExtend_SelectedSkillEntry == nil)) then
		local position = PetExtend_SelectedFocusEntry + 1;
		local skill = PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"][PetExtend_SelectedFocusEntry];
		
		if ((skill ~= nil) and (position <= 4) and (PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"][position])) then
			tremove(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"], PetExtend_SelectedFocusEntry);
			tinsert(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"], position, skill);
			PetExtend_SelectedFocusEntry = position;
		end
	end
	
	PetExtend_Update_FocusManagement();
	PetExtend_Update_SkillManagement();
	
end


function PetExtend_Move_PetSkill()
	
	if ((PetExtend_SelectedFocusEntry ~= nil) and (PetExtend_SelectedSkillEntry == nil)) then
		tremove(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"], PetExtend_SelectedFocusEntry);
		PetExtend_Populate_SkillManagement();
		PetExtend_Update_SkillManagement();
		PetExtend_Update_FocusManagement();
	elseif ((PetExtend_SelectedFocusEntry == nil) and (PetExtend_SelectedSkillEntry ~= nil)) then
		local skill = getglobal("PetExtend_SkillManagementEntry"..PetExtend_SelectedSkillEntry.."_LeftText"):GetText();
		tinsert(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Focus Priority"], skill);
		PetExtend_Populate_SkillManagement();
		PetExtend_Update_SkillManagement();
		PetExtend_Update_FocusManagement();
	end
	
	PetExtend_UpdateStatusFrame("focusindicator");
	
end


function PetExtend_Update_SkillManagement()
	
	PetExtend_Populate_SkillManagement();
	
	local line;
	for line = 1, 4 do
		if (PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"][line]) then
			getglobal("PetExtend_SkillManagementEntry"..line.."_LeftText"):SetText(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"][line]);
			getglobal("PetExtend_SkillManagementEntry"..line):Show();
			
			if ((PetExtend_SelectedSkillEntry ~= nil) and (line == PetExtend_SelectedSkillEntry)) then
				getglobal("PetExtend_SkillManagementEntry"..line):LockHighlight();
			else
				getglobal("PetExtend_SkillManagementEntry"..line):UnlockHighlight();
			end
		else
			getglobal("PetExtend_SkillManagementEntry"..line):Hide();
		end
	end
end

function PetExtend_Select_SkillManagement(id)
	
	PetExtend_SelectedSkillEntry = id;
	PetExtend_SelectedFocusEntry = nil;
	PetExtend_Update_SkillManagement();
	PetExtend_Update_FocusManagement();
	
end

function PetExtend_Populate_SkillManagement()
	
	--Go through all pet action slots and set the id's 
	for i=1, NUM_PET_ACTION_SLOTS, 1 do
		local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);
		if (name ~= nil) then
			if (PetExtend_PetAction[name]) then
				if ((not PetExtend_IsSkillInSkillManagement(name)) and (not PetExtend_IsSkillInFocusPriority(name))) then
					tinsert(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"], name);
				elseif ((PetExtend_IsSkillInFocusPriority(name)) and (PetExtend_IsSkillInSkillManagement(name))) then
					local position = PetExtend_IsSkillInSkillManagement(name);
					tremove(PetExtend_Config[UnitName("pet")][PetExtend_Config[UnitName("pet")].currentmode]["Skill Management"], position);
				end
			end
		end
	end
	
end


function PetExtend_PvPFeignDeath_DropDown_OnLoad()
	UIDropDownMenu_Initialize(this, PetExtend_PvPFeignDeath_Dropdown_Initialize);
	UIDropDownMenu_SetWidth(100);
end

function PetExtend_PvPFeignDeath_Dropdown_Initialize()
	local settings = {"Follow", "Stay", "Passive"};
	for k, v in settings do
		local info = {};
		info.text = settings[k];
		info.func = PetExtend_PvPFeignDeath_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function PetExtend_PvPFeignDeath_DropDown_OnClick()
	local settings = {"Follow", "Stay", "Passive"};
	UIDropDownMenu_SetSelectedID(PetExtend_PvPFeignDeath_DropDown, this:GetID());
	PetExtend_Config.pvpfeign_reaction = settings[this:GetID()];
end


function PetExtend_Scattershot_DropDown_OnLoad()
	UIDropDownMenu_Initialize(this, PetExtend_Scattershot_DropDown_Initialize);
	UIDropDownMenu_SetWidth(100);
end

function PetExtend_Scattershot_DropDown_Initialize()
	local settings = {"Follow", "Stay", "Passive"};
	for k, v in settings do
		local info = {};
		info.text = settings[k];
		info.func = PetExtend_Scattershot_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function PetExtend_Scattershot_DropDown_OnClick()
	local settings = {"Follow", "Stay", "Passive"};
	UIDropDownMenu_SetSelectedID(PetExtend_Scattershot_DropDown, this:GetID());
	PetExtend_Config.scattershot_reaction = settings[this:GetID()];
end


function PetExtend_PartyWarn_DropDown_OnLoad()
	UIDropDownMenu_Initialize(this, PetExtend_PartyWarn_DropDown_Initialize);
	UIDropDownMenu_SetWidth(100);
end

function PetExtend_PartyWarn_DropDown_Initialize()
	local settings = {"Console", "Say", "Party", "Raid", "Smart"};
	for k, v in settings do
		local info = {};
		info.text = settings[k];
		info.func = PetExtend_PartyWarn_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function PetExtend_PartyWarn_DropDown_OnClick()
	local settings = {"Console", "Say", "Party", "Raid", "Smart"};
	UIDropDownMenu_SetSelectedID(PetExtend_PartyWarn_DropDown, this:GetID());
	PetExtend_Config.partywarn_warning_channel = settings[this:GetID()];
end


function PetExtend_PartyWarn2_DropDown_OnLoad()
	UIDropDownMenu_Initialize(this, PetExtend_PartyWarn2_DropDown_Initialize);
	UIDropDownMenu_SetWidth(100);
end

function PetExtend_PartyWarn2_DropDown_Initialize()
	local settings = {"RP", "Default"};
	for k, v in settings do
		local info = {};
		info.text = settings[k];
		info.func = PetExtend_PartyWarn2_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function PetExtend_PartyWarn2_DropDown_OnClick()
	local settings = {"RP", "Default"};
	UIDropDownMenu_SetSelectedID(PetExtend_PartyWarn2_DropDown, this:GetID());
	PetExtend_Config.partywarn_style = settings[this:GetID()];
end
